| Assembly Source File
| Created 12/8/2001; 3:00:52 AM
|
|The Prototype C Style...
| void CallNextEV_hook(EVENT *ev);
|
|This replaces the following code:
|	void (*OldHook)(EVENT*);	
|	(unsigned long*)OldHook=*((unsigned long*)gpOldHandler);
|	if(OldHook)
|		OldHook(ev);
|
|The major difference being that this assembly language code
|places the EVENT parameter on the stack and in a2
|Most programs correctly assume that the parameter is on the stack,
|but TEOS assumes that it is in a2, so some extra steps are necessary
|
|If you don't want to support TEOS, then just remove the call to this code,
|and replace it with the above code...\
|
.data
	.even
	.globl	CallNextEV_hook
	
CallNextEV_hook:
	move.l gpOldHandler,%a0
	move.l (%a0),%a0
	
	cmp.w #0,%a0		/*Test to see if there is another EVENT hook to call*/
	beq.s FinishUp
	
	move.l %a2,-(%sp)
	
	move.l 8(%a6),-(%sp)	/*Place the EVENT parameter on the stack*/
	move.l (%sp),%a2	/*TEOS expects the EVENT parameter to be in a2*/
	jsr (%a0)		/*Call the hook*/
	addq.l #4,%sp		/*restore the stack*/
	
	move.l (%sp)+,%a2
	
FinishUp:
	rts
